--[[ macro should be: /run MillButtonSetup() /click MillButton ]]

local mill = CreateFrame("CheckButton","MillButton",UIParent,"SecureActionButtonTemplate")
mill:SetAttribute("type","macro")

local function findherb()
  local function f(b,s)
    if GetContainerItemLink(b,s) then
	local itemName,_,_,_,_,_,itemType = GetItemInfo(GetContainerItemLink(b,s))
	return (itemType=="Herb" or itemName=="Desecrated Herb") and select(2,GetContainerItemInfo(b,s))>=5
    end
  end
  for i=0,4 do
    for j=1,GetContainerNumSlots(i) do
      if f(i,j) then
        return i,j
      end
    end
  end
end  

function MillButtonSetup()
  local b,s = findherb()
  if (not b or not s) or LootFrame:IsVisible() or CastingBarFrame:IsVisible() or UnitCastingInfo("player") then
    -- do nothing if no herb, if looting or casting
    MillButton:SetAttribute("macrotext","")
    if not b then
      print("No more herbs in stacks of 5 or more.")
    end
  else
    MillButton:SetAttribute("macrotext","/cast Milling\n/use "..b.." "..s)
  end
end